package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallSkuLevelPriceApplicationService;
import com.jeesharp.business.modules.mall.dto.MallSkuLevelPriceSaveDTO;
import com.jeesharp.business.modules.mall.vo.MallSkuLevelPriceInfoVO;
import com.jeesharp.business.modules.mall.vo.MallSkuLevelPriceListVO;
import com.jeesharp.business.modules.mall.vo.MallSkuLevelPriceQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;

/**
 * 会员价管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/skuLevelPrice/v1")
@Tag(name = "会员价管理")
@AllArgsConstructor
public class MallSkuLevelPriceController extends BaseController {

    private final MallSkuLevelPriceApplicationService mallSkuLevelPriceApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallSkuLevelPriceInfoVO> info(@RequestParam("id") String id) {
        MallSkuLevelPriceInfoVO vo = mallSkuLevelPriceApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallSkuLevelPriceListVO>> list(@RequestBody MallSkuLevelPriceQueryVO query) {
        PageRespVO<MallSkuLevelPriceListVO> page = mallSkuLevelPriceApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallSkuLevelPriceSaveDTO dto) {
        mallSkuLevelPriceApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallSkuLevelPriceApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }
}
